/* Auto-generated by genmsg_cpp for file /home/east/ros_workspace/TestNode/srv/GetIpAddress.srv */
#ifndef TESTNODE_SERVICE_GETIPADDRESS_H
#define TESTNODE_SERVICE_GETIPADDRESS_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"

#include "ros/service_traits.h"




namespace TestNode
{
template <class ContainerAllocator>
struct GetIpAddressRequest_ {
  typedef GetIpAddressRequest_<ContainerAllocator> Type;

  GetIpAddressRequest_()
  {
  }

  GetIpAddressRequest_(const ContainerAllocator& _alloc)
  {
  }


  typedef boost::shared_ptr< ::TestNode::GetIpAddressRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::GetIpAddressRequest_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct GetIpAddressRequest
typedef  ::TestNode::GetIpAddressRequest_<std::allocator<void> > GetIpAddressRequest;

typedef boost::shared_ptr< ::TestNode::GetIpAddressRequest> GetIpAddressRequestPtr;
typedef boost::shared_ptr< ::TestNode::GetIpAddressRequest const> GetIpAddressRequestConstPtr;


template <class ContainerAllocator>
struct GetIpAddressResponse_ {
  typedef GetIpAddressResponse_<ContainerAllocator> Type;

  GetIpAddressResponse_()
  : ip()
  {
  }

  GetIpAddressResponse_(const ContainerAllocator& _alloc)
  : ip(_alloc)
  {
  }

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _ip_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  ip;


  typedef boost::shared_ptr< ::TestNode::GetIpAddressResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::GetIpAddressResponse_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct GetIpAddressResponse
typedef  ::TestNode::GetIpAddressResponse_<std::allocator<void> > GetIpAddressResponse;

typedef boost::shared_ptr< ::TestNode::GetIpAddressResponse> GetIpAddressResponsePtr;
typedef boost::shared_ptr< ::TestNode::GetIpAddressResponse const> GetIpAddressResponseConstPtr;

struct GetIpAddress
{

typedef GetIpAddressRequest Request;
typedef GetIpAddressResponse Response;
Request request;
Response response;

typedef Request RequestType;
typedef Response ResponseType;
}; // struct GetIpAddress
} // namespace TestNode

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::GetIpAddressRequest_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::GetIpAddressRequest_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::GetIpAddressRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "d41d8cd98f00b204e9800998ecf8427e";
  }

  static const char* value(const  ::TestNode::GetIpAddressRequest_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xd41d8cd98f00b204ULL;
  static const uint64_t static_value2 = 0xe9800998ecf8427eULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::GetIpAddressRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/GetIpAddressRequest";
  }

  static const char* value(const  ::TestNode::GetIpAddressRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::GetIpAddressRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "\n\
";
  }

  static const char* value(const  ::TestNode::GetIpAddressRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator> struct IsFixedSize< ::TestNode::GetIpAddressRequest_<ContainerAllocator> > : public TrueType {};
} // namespace message_traits
} // namespace ros


namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::GetIpAddressResponse_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::GetIpAddressResponse_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::GetIpAddressResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "9e9f1bacbbf36194990498b0461c2f3b";
  }

  static const char* value(const  ::TestNode::GetIpAddressResponse_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x9e9f1bacbbf36194ULL;
  static const uint64_t static_value2 = 0x990498b0461c2f3bULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::GetIpAddressResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/GetIpAddressResponse";
  }

  static const char* value(const  ::TestNode::GetIpAddressResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::GetIpAddressResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "string ip\n\
\n\
\n\
";
  }

  static const char* value(const  ::TestNode::GetIpAddressResponse_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::GetIpAddressRequest_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct GetIpAddressRequest_
} // namespace serialization
} // namespace ros


namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::GetIpAddressResponse_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.ip);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct GetIpAddressResponse_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace service_traits
{
template<>
struct MD5Sum<TestNode::GetIpAddress> {
  static const char* value() 
  {
    return "9e9f1bacbbf36194990498b0461c2f3b";
  }

  static const char* value(const TestNode::GetIpAddress&) { return value(); } 
};

template<>
struct DataType<TestNode::GetIpAddress> {
  static const char* value() 
  {
    return "TestNode/GetIpAddress";
  }

  static const char* value(const TestNode::GetIpAddress&) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::GetIpAddressRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "9e9f1bacbbf36194990498b0461c2f3b";
  }

  static const char* value(const TestNode::GetIpAddressRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::GetIpAddressRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/GetIpAddress";
  }

  static const char* value(const TestNode::GetIpAddressRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::GetIpAddressResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "9e9f1bacbbf36194990498b0461c2f3b";
  }

  static const char* value(const TestNode::GetIpAddressResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::GetIpAddressResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/GetIpAddress";
  }

  static const char* value(const TestNode::GetIpAddressResponse_<ContainerAllocator> &) { return value(); } 
};

} // namespace service_traits
} // namespace ros

#endif // TESTNODE_SERVICE_GETIPADDRESS_H

